diff --git a/doc/bashref.info b/doc/bashref.info
index 7f8fb3d2..04b945b9 100644
--- a/doc/bashref.info
+++ b/doc/bashref.info
@@ -2,12 +2,12 @@ This is bashref.info, produced by makeinfo version 4.5 from
 /usr/homes/chet/src/bash/src/doc/bashref.texi.
 
 This text is a brief description of the features that are present in
-the Bash shell (version 3.0-beta1, 20 April 2004).
+the Bash shell (version 3.0-rc1, 27 May 2004).
 
-   This is Edition 3.0, last updated 20 April 2004, of `The GNU Bash
-Reference Manual', for `Bash', Version 3.0-beta1.
+   This is Edition 3.0, last updated 27 May 2004, of `The GNU Bash
+Reference Manual', for `Bash', Version 3.0-rc1.
 
-   Copyright (C) 1988-2003 Free Software Foundation, Inc.
+   Copyright (C) 1988-2004 Free Software Foundation, Inc.
 
    Permission is granted to make and distribute verbatim copies of this
 manual provided the copyright notice and this permission notice are
@@ -37,10 +37,10 @@ Bash Features
 *************
 
    This text is a brief description of the features that are present in
-the Bash shell (version 3.0-beta1, 20 April 2004)..
+the Bash shell (version 3.0-rc1, 27 May 2004)..
 
-   This is Edition 3.0, last updated 20 April 2004, of `The GNU Bash
-Reference Manual', for `Bash', Version 3.0-beta1.
+   This is Edition 3.0, last updated 27 May 2004, of `The GNU Bash
+Reference Manual', for `Bash', Version 3.0-rc1.
 
    Bash contains features that appear in other popular shells, and some
 features that only appear in Bash.  Some of the shells that Bash has
@@ -2567,19 +2567,19 @@ standard.
 `trap'
           trap [-lp] [ARG] [SIGSPEC ...]
      The commands in ARG are to be read and executed when the shell
-     receives signal SIGSPEC.  If ARG is absent or equal to `-', all
-     specified signals are reset to the values they had when the shell
-     was started.  If ARG is the null string, then the signal specified
-     by each SIGSPEC is ignored by the shell and commands it invokes.
-     If ARG is not present and `-p' has been supplied, the shell
-     displays the trap commands associated with each SIGSPEC.  If no
-     arguments are supplied, or only `-p' is given, `trap' prints the
-     list of commands associated with each signal number in a form that
-     may be reused as shell input.  The `-l' option causes the shell to
-     print a list of signal names and their corresponding numbers.
-
-     Each SIGSPEC is either a signal name such as `SIGINT' (with or
-     without the `SIG' prefix) or a signal number.  If a SIGSPEC is `0'
+     receives signal SIGSPEC.  If ARG is absent (and there is a single
+     SIGSPEC) or equal to `-', each specified signal's disposition is
+     reset to the value it had when the shell was started.  If ARG is
+     the null string, then the signal specified by each SIGSPEC is
+     ignored by the shell and commands it invokes.  If ARG is not
+     present and `-p' has been supplied, the shell displays the trap
+     commands associated with each SIGSPEC.  If no arguments are
+     supplied, or only `-p' is given, `trap' prints the list of commands
+     associated with each signal number in a form that may be reused as
+     shell input.  The `-l' option causes the shell to print a list of
+     signal names and their corresponding numbers.  Each SIGSPEC is
+     either a signal name or a signal number.  Signal names are case
+     insensitive and the `SIG' prefix is optional.  If a SIGSPEC is `0'
      or `EXIT', ARG is executed when the shell exits.  If a SIGSPEC is
      `DEBUG', the command ARG is executed before every simple command,
      `for' command, `case' command, `select' command, every arithmetic
@@ -4092,6 +4092,11 @@ Variables::).
      value assigned, and the expanded value becomes the value assigned
      plus the number of seconds since the assignment.
 
+`SHELL'
+     The full pathname to the shell is kept in this environment
+     variable.  If it is not set when the shell starts, Bash assigns to
+     it the full pathname of the current user's login shell.
+
 `SHELLOPTS'
      A colon-separated list of enabled shell options.  Each word in the
      list is a valid argument for the `-o' option to the `set' builtin
@@ -5499,16 +5504,16 @@ Job Control Builtins
           kill -l [EXIT_STATUS]
      Send a signal specified by SIGSPEC or SIGNUM to the process named
      by job specification JOBSPEC or process ID PID.  SIGSPEC is either
-     a signal name such as `SIGINT' (with or without the `SIG' prefix)
-     or a signal number; SIGNUM is a signal number.  If SIGSPEC and
-     SIGNUM are not present, `SIGTERM' is used.  The `-l' option lists
-     the signal names.  If any arguments are supplied when `-l' is
-     given, the names of the signals corresponding to the arguments are
-     listed, and the return status is zero.  EXIT_STATUS is a number
-     specifying a signal number or the exit status of a process
-     terminated by a signal.  The return status is zero if at least one
-     signal was successfully sent, or non-zero if an error occurs or an
-     invalid option is encountered.
+     a case-insensitive signal name such as `SIGINT' (with or without
+     the `SIG' prefix) or a signal number; SIGNUM is a signal number.
+     If SIGSPEC and SIGNUM are not present, `SIGTERM' is used.  The
+     `-l' option lists the signal names.  If any arguments are supplied
+     when `-l' is given, the names of the signals corresponding to the
+     arguments are listed, and the return status is zero.  EXIT_STATUS
+     is a number specifying a signal number or the exit status of a
+     process terminated by a signal.  The return status is zero if at
+     least one signal was successfully sent, or non-zero if an error
+     occurs or an invalid option is encountered.
 
 `wait'
           wait [JOBSPEC or PID]
@@ -9039,6 +9044,7 @@ Parameter and Variable Index
 * RANDOM:                                Bash Variables.
 * REPLY:                                 Bash Variables.
 * SECONDS:                               Bash Variables.
+* SHELL:                                 Bash Variables.
 * SHELLOPTS:                             Bash Variables.
 * SHLVL:                                 Bash Variables.
 * show-all-if-ambiguous:                 Readline Init File Syntax.
@@ -9260,129 +9266,129 @@ Concept Index
 
 
 Tag Table:
-Node: Top1367
-Node: Introduction3520
-Node: What is Bash?3745
-Node: What is a shell?4833
-Node: Definitions7369
-Node: Basic Shell Features10109
-Node: Shell Syntax11327
-Node: Shell Operation12351
-Node: Quoting13636
-Node: Escape Character14898
-Node: Single Quotes15370
-Node: Double Quotes15705
-Node: ANSI-C Quoting16718
-Node: Locale Translation17661
-Node: Comments18544
-Node: Shell Commands19149
-Node: Simple Commands19910
-Node: Pipelines20531
-Node: Lists22397
-Node: Compound Commands24019
-Node: Looping Constructs24791
-Node: Conditional Constructs27225
-Node: Command Grouping34278
-Node: Shell Functions35714
-Node: Shell Parameters39976
-Node: Positional Parameters41547
-Node: Special Parameters42438
-Node: Shell Expansions45096
-Node: Brace Expansion47016
-Node: Tilde Expansion49332
-Node: Shell Parameter Expansion51664
-Node: Command Substitution58918
-Node: Arithmetic Expansion60240
-Node: Process Substitution61081
-Node: Word Splitting62118
-Node: Filename Expansion63570
-Node: Pattern Matching65694
-Node: Quote Removal69015
-Node: Redirections69301
-Node: Executing Commands76776
-Node: Simple Command Expansion77443
-Node: Command Search and Execution79364
-Node: Command Execution Environment81361
-Node: Environment84123
-Node: Exit Status85774
-Node: Signals86969
-Node: Shell Scripts88924
-Node: Shell Builtin Commands91435
-Node: Bourne Shell Builtins93010
-Node: Bash Builtins109893
-Node: The Set Builtin138015
-Node: Special Builtins146233
-Node: Shell Variables147205
-Node: Bourne Shell Variables147641
-Node: Bash Variables149618
-Node: Bash Features169123
-Node: Invoking Bash170005
-Node: Bash Startup Files175816
-Node: Interactive Shells180686
-Node: What is an Interactive Shell?181088
-Node: Is this Shell Interactive?181723
-Node: Interactive Shell Behavior182529
-Node: Bash Conditional Expressions185796
-Node: Shell Arithmetic189216
-Node: Aliases191956
-Node: Arrays194519
-Node: The Directory Stack197539
-Node: Directory Stack Builtins198245
-Node: Printing a Prompt201124
-Node: The Restricted Shell203833
-Node: Bash POSIX Mode205658
-Node: Job Control212304
-Node: Job Control Basics212770
-Node: Job Control Builtins217055
-Node: Job Control Variables221351
-Node: Command Line Editing222501
-Node: Introduction and Notation223499
-Node: Readline Interaction225116
-Node: Readline Bare Essentials226302
-Node: Readline Movement Commands228082
-Node: Readline Killing Commands229038
-Node: Readline Arguments230947
-Node: Searching231982
-Node: Readline Init File234159
-Node: Readline Init File Syntax235213
-Node: Conditional Init Constructs246857
-Node: Sample Init File249381
-Node: Bindable Readline Commands252564
-Node: Commands For Moving253763
-Node: Commands For History254612
-Node: Commands For Text257501
-Node: Commands For Killing260162
-Node: Numeric Arguments262292
-Node: Commands For Completion263419
-Node: Keyboard Macros267000
-Node: Miscellaneous Commands267559
-Node: Readline vi Mode272858
-Node: Programmable Completion273767
-Node: Programmable Completion Builtins279574
-Node: Using History Interactively286936
-Node: Bash History Facilities287615
-Node: Bash History Builtins290305
-Node: History Interaction294157
-Node: Event Designators296708
-Node: Word Designators297712
-Node: Modifiers299342
-Node: Installing Bash300739
-Node: Basic Installation301873
-Node: Compilers and Options304558
-Node: Compiling For Multiple Architectures305292
-Node: Installation Names306949
-Node: Specifying the System Type307760
-Node: Sharing Defaults308469
-Node: Operation Controls309134
-Node: Optional Features310085
-Node: Reporting Bugs318357
-Node: Major Differences From The Bourne Shell319532
-Node: Copying This Manual335280
-Node: GNU Free Documentation License335534
-Node: Builtin Index357927
-Node: Reserved Word Index361554
-Node: Variable Index363030
-Node: Function Index370023
-Node: Concept Index374636
+Node: Top1359
+Node: Introduction3504
+Node: What is Bash?3729
+Node: What is a shell?4817
+Node: Definitions7353
+Node: Basic Shell Features10093
+Node: Shell Syntax11311
+Node: Shell Operation12335
+Node: Quoting13620
+Node: Escape Character14882
+Node: Single Quotes15354
+Node: Double Quotes15689
+Node: ANSI-C Quoting16702
+Node: Locale Translation17645
+Node: Comments18528
+Node: Shell Commands19133
+Node: Simple Commands19894
+Node: Pipelines20515
+Node: Lists22381
+Node: Compound Commands24003
+Node: Looping Constructs24775
+Node: Conditional Constructs27209
+Node: Command Grouping34262
+Node: Shell Functions35698
+Node: Shell Parameters39960
+Node: Positional Parameters41531
+Node: Special Parameters42422
+Node: Shell Expansions45080
+Node: Brace Expansion47000
+Node: Tilde Expansion49316
+Node: Shell Parameter Expansion51648
+Node: Command Substitution58902
+Node: Arithmetic Expansion60224
+Node: Process Substitution61065
+Node: Word Splitting62102
+Node: Filename Expansion63554
+Node: Pattern Matching65678
+Node: Quote Removal68999
+Node: Redirections69285
+Node: Executing Commands76760
+Node: Simple Command Expansion77427
+Node: Command Search and Execution79348
+Node: Command Execution Environment81345
+Node: Environment84107
+Node: Exit Status85758
+Node: Signals86953
+Node: Shell Scripts88908
+Node: Shell Builtin Commands91419
+Node: Bourne Shell Builtins92994
+Node: Bash Builtins109942
+Node: The Set Builtin138064
+Node: Special Builtins146282
+Node: Shell Variables147254
+Node: Bourne Shell Variables147690
+Node: Bash Variables149667
+Node: Bash Features169378
+Node: Invoking Bash170260
+Node: Bash Startup Files176071
+Node: Interactive Shells180941
+Node: What is an Interactive Shell?181343
+Node: Is this Shell Interactive?181978
+Node: Interactive Shell Behavior182784
+Node: Bash Conditional Expressions186051
+Node: Shell Arithmetic189471
+Node: Aliases192211
+Node: Arrays194774
+Node: The Directory Stack197794
+Node: Directory Stack Builtins198500
+Node: Printing a Prompt201379
+Node: The Restricted Shell204088
+Node: Bash POSIX Mode205913
+Node: Job Control212559
+Node: Job Control Basics213025
+Node: Job Control Builtins217310
+Node: Job Control Variables221622
+Node: Command Line Editing222772
+Node: Introduction and Notation223770
+Node: Readline Interaction225387
+Node: Readline Bare Essentials226573
+Node: Readline Movement Commands228353
+Node: Readline Killing Commands229309
+Node: Readline Arguments231218
+Node: Searching232253
+Node: Readline Init File234430
+Node: Readline Init File Syntax235484
+Node: Conditional Init Constructs247128
+Node: Sample Init File249652
+Node: Bindable Readline Commands252835
+Node: Commands For Moving254034
+Node: Commands For History254883
+Node: Commands For Text257772
+Node: Commands For Killing260433
+Node: Numeric Arguments262563
+Node: Commands For Completion263690
+Node: Keyboard Macros267271
+Node: Miscellaneous Commands267830
+Node: Readline vi Mode273129
+Node: Programmable Completion274038
+Node: Programmable Completion Builtins279845
+Node: Using History Interactively287207
+Node: Bash History Facilities287886
+Node: Bash History Builtins290576
+Node: History Interaction294428
+Node: Event Designators296979
+Node: Word Designators297983
+Node: Modifiers299613
+Node: Installing Bash301010
+Node: Basic Installation302144
+Node: Compilers and Options304829
+Node: Compiling For Multiple Architectures305563
+Node: Installation Names307220
+Node: Specifying the System Type308031
+Node: Sharing Defaults308740
+Node: Operation Controls309405
+Node: Optional Features310356
+Node: Reporting Bugs318628
+Node: Major Differences From The Bourne Shell319803
+Node: Copying This Manual335551
+Node: GNU Free Documentation License335805
+Node: Builtin Index358198
+Node: Reserved Word Index361825
+Node: Variable Index363301
+Node: Function Index370351
+Node: Concept Index374964
 
 End Tag Table
diff --git a/doc/bashref.ps b/doc/bashref.ps
index e70132be..1b4068d5 100644
--- a/doc/bashref.ps
+++ b/doc/bashref.ps
@@ -8,7 +8,7 @@
 %DVIPSWebPage: (www.radicaleye.com)
 %DVIPSCommandLine: dvips -D 600 -t letter -o bashref.ps bashref.dvi
 %DVIPSParameters: dpi=600, compressed
-%DVIPSSource:  TeX output 2004.05.04:1027
+%DVIPSSource:  TeX output 2004.06.01:1227
 %%BeginProcSet: texc.pro
 %!
 /TeXDict 300 dict def TeXDict begin/N{def}def/B{bind def}N/S{exch}N/X{S
@@ -2539,8 +2539,8 @@ letter
 %%Page: 1 1
 1 0 bop 150 1318 a Fu(Bash)64 b(Reference)j(Man)-5 b(ual)p
 150 1385 3600 34 v 2361 1481 a Ft(Reference)31 b(Do)s(cumen)m(tation)h
-(for)e(Bash)2178 1589 y(Edition)f(3.0,)i(for)f Fs(Bash)g
-Ft(V)-8 b(ersion)30 b(3.0-b)s(eta1.)3333 1697 y(April)e(2004)150
+(for)e(Bash)2276 1589 y(Edition)f(3.0,)i(for)g Fs(Bash)e
+Ft(V)-8 b(ersion)30 b(3.0-rc1.)3364 1697 y(Ma)m(y)h(2004)150
 4935 y Fr(Chet)45 b(Ramey)-11 b(,)46 b(Case)g(W)-11 b(estern)46
 b(Reserv)l(e)g(Univ)l(ersit)l(y)150 5068 y(Brian)f(F)-11
 b(o)l(x,)45 b(F)-11 b(ree)45 b(Soft)l(w)l(are)h(F)-11
@@ -2548,12 +2548,12 @@ b(oundation)p 150 5141 3600 17 v eop
 %%Page: 2 2
 2 1 bop 150 2889 a Ft(This)34 b(text)i(is)f(a)h(brief)e(description)g
 (of)h(the)h(features)g(that)g(are)g(presen)m(t)g(in)e(the)i(Bash)f
-(shell)f(\(v)m(ersion)150 2999 y(3.0-b)s(eta1,)f(20)e(April)d(2004\).)
-150 3133 y(This)k(is)h(Edition)e(3.0,)36 b(last)e(up)s(dated)e(20)j
-(April)c(2004,)37 b(of)d Fq(The)f(GNU)h(Bash)g(Reference)g(Man)m(ual)p
+(shell)f(\(v)m(ersion)150 2999 y(3.0-rc1,)e(27)g(Ma)m(y)f(2004\).)150
+3133 y(This)j(is)h(Edition)e(3.0,)39 b(last)c(up)s(dated)f(27)j(Ma)m(y)
+g(2004,)i(of)c Fq(The)h(GNU)g(Bash)g(Reference)g(Man)m(ual)p
 Ft(,)h(for)150 3243 y Fs(Bash)p Ft(,)29 b(V)-8 b(ersion)30
-b(3.0-b)s(eta1.)150 3377 y(Cop)m(yrigh)m(t)602 3374 y(c)577
-3377 y Fp(\015)g Ft(1988-2003)k(F)-8 b(ree)32 b(Soft)m(w)m(are)f(F)-8
+b(3.0-rc1.)150 3377 y(Cop)m(yrigh)m(t)602 3374 y(c)577
+3377 y Fp(\015)g Ft(1988-2004)k(F)-8 b(ree)32 b(Soft)m(w)m(are)f(F)-8
 b(oundation,)31 b(Inc.)150 3512 y(P)m(ermission)f(is)i(gran)m(ted)h(to)
 f(mak)m(e)i(and)d(distribute)f(v)m(erbatim)i(copies)g(of)g(this)f(man)m
 (ual)h(pro)m(vided)f(the)150 3621 y(cop)m(yrigh)m(t)g(notice)f(and)g
